'From Squeak3.6 of ''6 October 2003'' [latest update: #5429] on 2 December 2004 at 4:24:11 am'!
SimAction subclass: #PickupItemAction
	instanceVariableNames: 'item '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Content'!
!PickupItemAction commentStamp: 'ACK 11/5/2004 02:23' prior: 0!
This SimAction is used to make a person pickup an Item.!


!PickupItemAction methodsFor: 'accessors' stamp: 'VU 11/6/2004 15:32'!
name
  "Returns the name of the action."
  ^ 'Pick up ', self item name.! !

!PickupItemAction methodsFor: 'accessors' stamp: 'dqn 11/22/2004 21:42'!
object
	^ item.! !


!PickupItemAction methodsFor: 'actions' stamp: 'JMC 12/2/2004 04:23'!
doAction: aWorldObject
	"applies the effects of the action to the persons factors and causes the action to occur"

	| currPerson |

	currPerson := aWorldObject.

	(effects) do: [:effect |
		currPerson addPersonalEffect: effect].


	"Pickup the Item"
	currPerson pickupItem: self item.

	"Done with this action"
	currPerson setAction: (DoNothing new).! !

!PickupItemAction methodsFor: 'actions' stamp: 'ACK 10/30/2004 22:00'!
interactionsFor: aWorldObject
	"returning a bag of actions that can be performed "

	| availableActions |

	availableActions := Bag new.

	"give the person the option to pass through of the door is not locked"
	(self isLocked) isFalse: [
		(aWorldObject isKindOf: Person) ifTrue: [availableActions add: (ExitAction new)].
	].

	^availableActions.! !

!PickupItemAction methodsFor: 'actions' stamp: 'VU 10/30/2004 20:34'!
item
  "Returns the item to be picked up."
  ^ item.! !

!PickupItemAction methodsFor: 'actions' stamp: 'VU 10/30/2004 20:34'!
item: anItem
  "Sets the item to be picked up."
  item := anItem.! !


!PickupItemAction methodsFor: 'creation' stamp: 'JMC 11/6/2004 18:40'!
initialize
	"Set the factors that this action affects"

	super initialize.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PickupItemAction class
	instanceVariableNames: ''!

!PickupItemAction class methodsFor: 'as yet unclassified' stamp: 'ACK 10/30/2004 14:16'!
new
 	"create"
	
	^super new initialize.
! !
