Item subclass: #Radio
	instanceVariableNames: 'fileName player status '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Content'!
!Radio commentStamp: 'dqn 11/7/2004 03:40' prior: 0!
Represent a radio. Can stop, play, resume, pause.!


!Radio methodsFor: 'as yet unclassified' stamp: 'dqn 11/4/2004 17:07'!
fileName
	^fileName.! !

!Radio methodsFor: 'as yet unclassified' stamp: 'dqn 11/4/2004 17:07'!
fileName: aFileName
	fileName _ aFileName.! !

!Radio methodsFor: 'as yet unclassified' stamp: 'dqn 11/7/2004 04:01'!
initialize
  "Initializes this radio"

  super initialize.

  self name: 'Radio'.
  self description: 'Play a song'.
  self fileName: 'track1.mp3'.
	status = 'Stop'.
! !

!Radio methodsFor: 'as yet unclassified' stamp: 'dqn 11/7/2004 03:48'!
interactionsFor: aWorldObject
  "Returns a list of actions that can be performed on the book."

  | actions |
	(status = 'Stop') ifTrue:
	[
		status _ 'Play'.
	]
	ifFalse:
	[
		status _ 'Stop'. 
	].
  actions := super interactionsFor: aWorldObject.
  actions add: (RadioMessage new owner: self; name: status).

  ^ actions.! !


!Radio methodsFor: 'actions' stamp: 'dqn 11/7/2004 03:27'!
pause
	"pause the radio"
	player isNil
		ifFalse: [player pause]! !

!Radio methodsFor: 'actions' stamp: 'dqn 11/7/2004 03:27'!
play
	"play the radio"
	player isNil
		ifTrue: [self turnOn].
	player isNil
		ifFalse: [player play].
! !

!Radio methodsFor: 'actions' stamp: 'dqn 11/7/2004 03:27'!
resume
	"resume the radio"
	player isNil
		ifFalse: [player resumePlaying.]! !

!Radio methodsFor: 'actions' stamp: 'dqn 11/7/2004 03:27'!
stop
	"stop the radio"
	self pause.
	player isNil
		ifFalse: [player soundPosition: 0.0]! !

!Radio methodsFor: 'actions' stamp: 'dqn 11/7/2004 03:27'!
turnOn
	"turn on the radio"
	player _ StreamingMP3Sound onFileNamed: fileName.! !
