SortedCollection subclass: #MessageQueue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Engine'!
!MessageQueue commentStamp: 'JMC 10/29/2004 23:09' prior: 0!
The MessageQueue is simply used to handle the implementation of dealing with GameEngine
messages.

It is used to hold both the kernelMessages as well as the gameMessages.

Note that the MessageQueue Object checks to ensure that timestamp data is fulfilled.
!


!MessageQueue methodsFor: 'modifiers' stamp: 'JMC 11/17/2004 20:27'!
dequeue
	"Remove the first element if it is ready to be handled"

	self first ifNil: [ ^nil. ].

	(Time now) >= (self first time) ifTrue: [ ^self removeFirst ] ifFalse: [ ^nil ].


! !

!MessageQueue methodsFor: 'modifiers' stamp: 'JMC 11/14/2004 16:09'!
enqueue: toAdd
	"Add toAdd to the Queue"

	self add: toAdd.! !

!MessageQueue methodsFor: 'modifiers' stamp: 'JMC 11/14/2004 16:04'!
peek
	"Return the next in the Queue"

	! !


!MessageQueue methodsFor: 'Overrides' stamp: 'JMC 11/14/2004 16:25'!
first
	"Answer the first element of the receiver.
	Raise an error if the collection is empty."

	self size = 0 ifTrue: [^nil].
	^ self at: 1! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MessageQueue class
	instanceVariableNames: ''!

!MessageQueue class methodsFor: 'Initialization' stamp: 'JMC 11/14/2004 16:03'!
new
	"Create an instance of this class, this wraps SortedCollection functionality for ease of programming"

	^(super sortBlock: [:x :y | (x time) <= (y time) ] ).

! !
