CriticalMessage subclass: #ChangeViewMessage
	instanceVariableNames: 'location '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Message'!
!ChangeViewMessage commentStamp: 'VU 11/6/2004 15:45' prior: 0!
This is a message to the game engine that tells it that the user now wants to view a different location.!


!ChangeViewMessage methodsFor: 'access' stamp: 'VU 11/6/2004 15:47'!
location
  "Returns the location to which we want to change that view."
  ^ location.! !

!ChangeViewMessage methodsFor: 'access' stamp: 'VU 11/6/2004 15:47'!
location: aLocation
  "Sets the location that we want to change the view to."
  location := aLocation.! !

!ChangeViewMessage methodsFor: 'access' stamp: 'VU 11/6/2004 15:51'!
name
  "Returns the name of the message."
  ^ 'View Location'.! !


!ChangeViewMessage methodsFor: 'process' stamp: 'VU 11/6/2004 16:11'!
process
	"Changes the view."

	"First, tell the GameEngine that we have a new location:"
	GameEngine instance currentLocation: self location.

	"If we have a new location, obviously, the old selection should no longer be valid:"
	GameEngine instance currentPerson: nil.

	"Now, handle the UI:"
	UIManager instance setLocationView: self location.! !
