SimMessage subclass: #CreateThingMessage
	instanceVariableNames: 'location floorObject thingClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Message'!
!CreateThingMessage commentStamp: 'dqn 11/7/2004 00:44' prior: 0!
This is a message to the game engine that tells it create a new thing.!


!CreateThingMessage methodsFor: 'process' stamp: 'VU 11/6/2004 18:52'!
process
  "Creates the thing and puts it into the world."

  | thing |

  thing := self thing new.
  self location addWorldObject: thing at: self floor coordinates x at: self floor coordinates y.! !


!CreateThingMessage methodsFor: 'access' stamp: 'VU 11/6/2004 18:33'!
floor
  "Returns the MapObject for the floor tile where the item will be put upon creation."
  ^floorObject.! !

!CreateThingMessage methodsFor: 'access' stamp: 'VU 11/6/2004 18:33'!
floor: aMapObject
  "Sets the map object that the item created will be put on."
  floorObject := aMapObject.! !

!CreateThingMessage methodsFor: 'access' stamp: 'VU 11/6/2004 18:32'!
location
  "Returns the location in which the thing will be created."
  ^location.! !

!CreateThingMessage methodsFor: 'access' stamp: 'VU 11/6/2004 18:32'!
location: aLocation
  "Sets the location that the thing will be created in."
  location := aLocation.! !

!CreateThingMessage methodsFor: 'access' stamp: 'VU 11/6/2004 18:34'!
thing
  "Returns the class of the thing that will be created."
  ^thingClass.! !

!CreateThingMessage methodsFor: 'access' stamp: 'VU 11/6/2004 18:34'!
thing: aClass
  "Sets the class of the thing that will be created."
  thingClass := aClass.! !
