SimMessage subclass: #MovePersonMessage
	instanceVariableNames: 'newPos currLoc '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Message'!
!MovePersonMessage commentStamp: 'dqn 11/7/2004 00:46' prior: 0!
This is a message to the game engine that tells it that the person (message's owner) now wants to move to a different location.!


!MovePersonMessage methodsFor: 'access' stamp: 'VU 11/7/2004 12:54'!
name
  "Returns the name of the message."
  ^ 'Move here'.! !


!MovePersonMessage methodsFor: 'initialize' stamp: 'dqn 11/7/2004 19:14'!
coordinates
	^ newPos.! !

!MovePersonMessage methodsFor: 'initialize' stamp: 'JMC 10/30/2004 22:39'!
coordinates: aPoint
	"Take in the position to move the person to"

	newPos _ aPoint.
! !

!MovePersonMessage methodsFor: 'initialize' stamp: 'dqn 11/7/2004 19:15'!
location
	^ currLoc! !

!MovePersonMessage methodsFor: 'initialize' stamp: 'JMC 10/30/2004 22:40'!
location: currentLocation
	"The location the person is currently in"

	currLoc _ currentLocation.

! !


!MovePersonMessage methodsFor: 'process' stamp: 'dqn 11/22/2004 20:12'!
process
	"Perform the Action of moving this person"

"	currLoc moveMapObject: owner to: newPos."
	(owner finalMessage isNil) ifFalse:
	[
		(owner finalMessage == self) ifTrue:
		[
			owner finalMessage: nil.
		].
		^ self.
	].

	"he is doing something already"
	(owner currentAction isKindOf: DoNothing) ifFalse:
	[
		Transcript show: 'In MovePersonMessage, he is doing ', owner currentAction printString; cr.
		^self.
	].

	"he already moved to a new location"
	(owner location == currLoc) ifFalse:
	[
		^ self.
	].
	owner finalMessage: self.
	owner runTo: newPos.
! !
