CreatePersonMessage subclass: #UserCreatePersonMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Message'!
!UserCreatePersonMessage commentStamp: 'dqn 11/7/2004 00:49' prior: 0!
This is a message to the game engine that tells it to create a new person.!


!UserCreatePersonMessage methodsFor: 'process' stamp: 'VU 11/7/2004 19:45'!
process
	"Will ask the user to input the name and gender of the person they want to create."

	| classes sChoices cname choice |

	self pname:
		(FillInTheBlank request: 'Please name the person'
			initialAnswer: RandomUtilities randomName).
	(self pname = '') ifTrue: [^self.].  "Means user pressed cancel"

	self gender: (
		RadioButtonDialog
			request: 'What gender will it be?'
			withValues: { #male. #female }
	).
	(self gender = '') ifTrue: [^self.].  "Means user pressed cancel"

	self major:
		(FillInTheBlank request: 'Please choose the person''s major.'
			initialAnswer: 'Computer Science').
	(self major = '') ifTrue: [^self.].  "Means user pressed cancel"

	classes := Stereotype subclasses.

	sChoices := OrderedCollection new.
	classes do: [ :c |
		sChoices add: c name.
	].

	cname := RadioButtonDialog
			request: 'What about personality?'
			withValues: sChoices.
	(cname = '') ifTrue: [^self.].  "Means user pressed cancel"

	choice := nil.

	classes do: [ :c |
		((c name) = cname) ifTrue: [
			choice := c.
		].
	].

	self stereotype: choice new.

	super process.! !


!UserCreatePersonMessage methodsFor: 'access' stamp: 'VU 11/6/2004 17:55'!
name
  "Returns the name of the message"
  ^ 'Create new person'.! !
