CreateThingMessage subclass: #UserCreateThingMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Message'!
!UserCreateThingMessage commentStamp: 'dqn 11/7/2004 00:49' prior: 0!
This is a message to the game engine that tells it to create a new thing.!


!UserCreateThingMessage methodsFor: 'process' stamp: 'VU 11/27/2004 14:23'!
process
  "Asks the user which item he wants to create and creates that item."

  | classes menu msg |

  classes := self privateGetAvailableItemList.

  "Create the menu:"
  menu := MenuMorph entitled: 'Select a Thing:'.

  classes do: [ :class |
    msg := CreateThingMessage new.
    msg time: 0.
    msg floor: self floor.
    msg location: self location.
    msg thing: class.

    menu
		add: class name
		target: GameEngine instance
		selector: #fireKernelMessage:
		argument: msg.
  ].

  menu position: self floor position.
  menu popUpInWorld: World.! !


!UserCreateThingMessage methodsFor: 'private' stamp: 'VU 11/6/2004 18:57'!
privateGetAvailableItemList
  "Returns the list of classes of all available things."

  | result |

  result := Bag new.

  Furniture subclassesDo: [ :sc |
    result add: sc.
  ].

  Item subclassesDo: [ :sc |
    result add: sc.
  ].

  ^ result.! !


!UserCreateThingMessage methodsFor: 'access' stamp: 'VU 11/7/2004 12:54'!
name
  "Returns the name of the message"
  ^'Create new thing'.! !
