TestCase subclass: #PersonTest
	instanceVariableNames: 'myPerson myLocation item1 '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Model-Test'!
!PersonTest commentStamp: 'ACK 11/5/2004 02:03' prior: 0!
Test the basic functionality of a Person.!


!PersonTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 20:05'!
setUp
	"creating a person for testing"

	myPerson := Person new.

	myPerson name: 'Testy Person'.
	myPerson gender: #male.

	myLocation := Location new.

	myPerson changeLocation: myLocation.

	item1 := Item new.
	item1 addEffect: (SleepEffect new).
! !

!PersonTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 23:18'!
testInteractionsFor

	"testing if correct actions are returned"

	self assert: (myPerson interactionsFor: (Person new)) size > 0.
	self deny: (myPerson interactionsFor: (Item new)) size > 0.! !

!PersonTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 20:28'!
testItem
	"Tests that Items are added correctly and affect people acordingly"

	

	self assert: (myPerson factor: 'sleep') = 'Error: Factor Does not Exist'.

	myPerson pickupItem: item1.

	self assert: (myPerson factor: 'sleep') > 0.
	
	"This should not work b/c the grid is not initialized in this test"
	self deny: (myPerson factor: 'sleep') = 0.
	
	! !

!PersonTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 20:36'!
testOther
	"This tests some accessors and modifiers that are not tested by use in other tests"

	! !

!PersonTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 17:21'!
testWriteXML
	"This function is tested indirectly for all classes that use it.  It is used to write out some of  the situations that are loaded for testing.  Since the situations are loaded correctly and those tests work, it can be assumed the that the situations were written out correctly."! !
