TestCase subclass: #PortalTest
	instanceVariableNames: 'myPortal '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Model-Test'!
!PortalTest commentStamp: 'ACK 11/5/2004 02:03' prior: 0!
Test the basic functionality of a Portal.!


!PortalTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 16:56'!
setUp
	"setup a portal for testing"


	myPortal := Portal new.

	myPortal alignment: #north.
	myPortal locked: true.! !

!PortalTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 17:08'!
testInteractionsFor
	"Testing to see if portal works"

	
	self deny: (myPortal interactionsFor: (Item new)) size > 0.

	myPortal locked: false.
	self assert: (myPortal interactionsFor: (Person new)) size > 0.

	myPortal locked: true.	
	self deny: (myPortal interactionsFor: (Person new)) size > 0.
	
	self deny: (myPortal interactionsFor: (Thing new)) size > 0.! !

!PortalTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 16:59'!
testOther
	"Testing other accessors and modifiers that are used"

	self assert: myPortal locked.
	
	myPortal locked: false.

	self deny: myPortal locked.
	
	self assert: myPortal alignment = #north.
	
	myPortal alignment: #south.
	
	self deny: myPortal alignment = #north.

	self assert: myPortal alignment = #south.
! !

!PortalTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 17:20'!
testWriteXML
	"This function is tested indirectly for all classes that use it.  It is used to write out some of  the situations that are loaded for testing.  Since the situations are loaded correctly and those tests work, it can be assumed the that the situations were written out correctly."! !
