TestCase subclass: #SimActionTest
	instanceVariableNames: 'myAction '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Model-Test'!
!SimActionTest commentStamp: 'ACK 11/5/2004 02:03' prior: 0!
Test the basic functionality of a SimAction.!


!SimActionTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 17:53'!
setUp
	"setUp an action for testing"

	myAction := SimAction new.

! !

!SimActionTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 18:05'!
testEffects
	"Make sure effects are added and reported correctly"

	| aBag sleepEffect hungryEffect |

	aBag := Bag new.
	sleepEffect := (SleepEffect new).
	hungryEffect := (HungryEffect new).	

	aBag add: sleepEffect.

	self assert: myAction effects size = 0.

	myAction effects: aBag.

	self assert: myAction effects size = 1.

	self assert: ((myAction effects) includes: sleepEffect).

	myAction addEffect: hungryEffect.

	self assert: ((myAction effects) includes: sleepEffect).

	
	! !

!SimActionTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 17:21'!
testWriteXML
	"This function is tested indirectly for all classes that use it.  It is used to write out some of  the situations that are loaded for testing.  Since the situations are loaded correctly and those tests work, it can be assumed the that the situations were written out correctly."! !
