TestCase subclass: #WorldObjectTest
	instanceVariableNames: 'myWorldObject '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Model-Test'!
!WorldObjectTest commentStamp: 'ACK 11/5/2004 02:03' prior: 0!
Test the basic functionality of a WorldObject.!


!WorldObjectTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 23:25'!
setUp
	"create a world object for testing"

	myWorldObject := WorldObject new.! !

!WorldObjectTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 23:32'!
testAttribute
	"Make sure attributes are set correctly"

	myWorldObject attribute: 'Hello' is: 42.

	self assert: ((myWorldObject attribute: 'Hello') = 42).
	"that should be enough... this is not too exciting"! !

!WorldObjectTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 23:46'!
testEffects
	"Testing if effects can be added"

	self assert: (myWorldObject effectCount = 0).

	myWorldObject addEffect: (SleepEffect new).

	self assert: (myWorldObject effectCount = 1).



	
	
! !

!WorldObjectTest methodsFor: 'tests' stamp: 'ACK 11/2/2004 23:24'!
testWriteXML
	"This function is tested indirectly for all classes that use it.  It is used to write out some of  the situations that are loaded for testing.  Since the situations are loaded correctly and those tests work, it can be assumed the that the situations were written out correctly."! !
