Movable subclass: #Item
	instanceVariableNames: 'name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Model'!
!Item commentStamp: 'ACK 11/5/2004 02:13' prior: 0!
The Item class defines items, an extension of Object, which can be taken by People as well as affect the people in a Room.

Items are held by both People and Rooms and, as such, can cause various effects depending on their location.!


!Item methodsFor: 'modifiers' stamp: 'ACK 10/29/2004 20:16'!
name: newName.
	"sets this items name"

	name := newName.

! !


!Item methodsFor: 'accessors' stamp: 'ACK 10/29/2004 20:15'!
name
	"Returns this items name"

	^name.! !


!Item methodsFor: 'creation' stamp: 'ACK 10/29/2004 20:17'!
initialize
	"create an item"

	^super initialize.! !


!Item methodsFor: 'xml' stamp: 'ACK 10/29/2004 20:21'!
tagName
	^ 'item'.! !

!Item methodsFor: 'xml' stamp: 'dqn 10/31/2004 20:01'!
writeXML: xmlWriter
	"Writes XML for Item"
	xmlWriter startTag: self tagName.

	xmlWriter attribute: 'name' value: (self name asString).
	xmlWriter attribute: 'description' value: (self description asString).
	xmlWriter endTag.

	"Write Attributes"
     xmlWriter startTag: 'attributes'; endTag.
     WorldObject xmlizeDictionary: attributes using: xmlWriter tagged: 'attribute'.
     xmlWriter endTag: 'attributes'.

	self writeCoordinates: xmlWriter.

	"Write item effects"
	xmlWriter startTag: 'effects'; endTag.
	WorldObject xmlizeBag: effectBag using: xmlWriter tagged: 'effect'.
	xmlWriter endTag: 'effects'.

	
	xmlWriter endTag: self tagName. "Close the tag </Item> and return"! !


!Item methodsFor: 'actions' stamp: 'VU 10/30/2004 20:34'!
interactionsFor: aWorldObject
	"returning a bag of actions that can be performed "

	| availableActions |

	availableActions := Bag new.

	" add talk action if the object is an item "
	(aWorldObject isKindOf: Person) ifTrue: [availableActions add: (PickupItemAction new item: self)].

	^availableActions.! !


!Item methodsFor: 'as yet unclassified' stamp: 'VU 11/6/2004 15:38'!
viewTextRepresentation
	"Returns an array of strings that can be displayed to screen to give information about the WorldObject"

	| retArray |

	retArray := OrderedCollection new.
	retArray add: ('Name: ', self name).

	retArray add: ''.

	retArray add: ('Description: ', self description).

	retArray add: ''.

	"add attributes"
	retArray add: 'Attributes: '.
	attributes associationsDo: [:assoc |
		retArray add: assoc asString.
	].

	^retArray.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Item class
	instanceVariableNames: ''!

!Item class methodsFor: 'as yet unclassified' stamp: 'ACK 10/29/2004 20:17'!
new
	"create and instance"

	^super new initialize.! !
