Object subclass: #RandomUtilities
	instanceVariableNames: ''
	classVariableNames: 'NameList '
	poolDictionaries: ''
	category: 'SimTech-Model'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RandomUtilities class
	instanceVariableNames: ''!

!RandomUtilities class methodsFor: 'as yet unclassified' stamp: 'VU 12/2/2004 01:47'!
blankWorld
	"Creates a blank world."

	| area |

	"First, reset the world:"
	GameEngine delete.

	"Create the blank location"
	area := Location new.
	area name: 'Outside'.
	area width: 20 height: 20.

	GameEngine instance changeLocation: area.! !

!RandomUtilities class methodsFor: 'as yet unclassified' stamp: 'VU 12/2/2004 02:23'!
demoWorld
	"Creates a demo world."

	| area shaft |

	"First, reset the world:"
	GameEngine delete.

	"Create the blank location"
	area := Location new.
	area name: 'Outside'.
	area width: 20 height: 20.

	shaft := Shaft new.
	area addWorldObject: shaft at: 10 at: 9.

	GameEngine instance changeLocation: area.! !

!RandomUtilities class methodsFor: 'as yet unclassified' stamp: 'VU 11/7/2004 13:05'!
fileInAll
	"Files in all the files that we need for the project."

	FileInOut fromDirectory: (PathManager instance sourcePath fullName) fileInCategories:
	#(
		'Vladimir-Utilities'
		'SimTech-ResourceManagement'
		'SimTech-Model'
		'SimTech-Engine'
		'SimTech-Message'
		'SimTech-View'
		'SimTech-Content'
		'SimTech-Utilities'
		'SimTech-Model-Test'
	).! !

!RandomUtilities class methodsFor: 'as yet unclassified' stamp: 'VU 11/7/2004 13:07'!
fileOutAll
	"Files out all the files that we need for the project."

	| path |

	path := PathManager instance sourcePath fullName.

	FileInOut fileOutCategory: 'Vladimir-Utilities' to: path.
	FileInOut fileOutCategory: 'SimTech-ResourceManagement' to: path.
	FileInOut fileOutCategory: 'SimTech-Model' to: path.
	FileInOut fileOutCategory: 'SimTech-Engine' to: path.
	FileInOut fileOutCategory: 'SimTech-Message' to: path.
	FileInOut fileOutCategory: 'SimTech-View' to: path.
	FileInOut fileOutCategory: 'SimTech-Content' to: path.
	FileInOut fileOutCategory: 'SimTech-Utilities' to: path.
	FileInOut fileOutCategory: 'SimTech-Model-Test' to: path.
! !

!RandomUtilities class methodsFor: 'as yet unclassified' stamp: 'VU 11/6/2004 16:36'!
initialize
	"Initializes class variables."

	NameList := #(
		'Puyan'
		'Vladimir Urazov'
		'Jose Caban'
		'Andrew Knight'
		'Dung Nguyen'
		'Bill Leahy'
		'Mike McCraken'
		'Rich LeBlanc'
		'Ellie Harmon'
		'Chris Hunt'
		'Nishant Mehta'
		'Jason Ho'
		'Jason Whitehurst'
		'Patrick Carnahan'
		'Matt Kurjanowicz'
		'Garry Boyer'
		'Johnny Bravo'
		'Jimi Hendrix'
		'Jimi Malcolm'
		'Adrian Abraham'
		'Joseph Czechowski'
		'Andrew Pilsch'
		'Ryan Seekely'
		'Hemal Shah'
		'Jennifer Hartmeyer'
		'Leo Singleton'
		'Ian Turner'
		'Zachary Crowell'
		'Bill Gates'
		'Alan Kay'
		'Alan Kay' "Man, he's so cool, he *deserves* three times the chance of being selected"
		'Alan Kay'
		'Steve Jobs'
		'John Smith'
		'Mike Thielvoldt'
		'Niel Chopra'
		'Greg Hannum'
		'Megan Shelby'
		'Sarah Shelby'
		'Margaret Thatcher'
		'William Smith'
		'Mark Wahlberg'
		'John Romero'
		'Sid Meier'
		'John Carmack'
	).! !

!RandomUtilities class methodsFor: 'as yet unclassified' stamp: 'VU 11/6/2004 16:22'!
randomName
	"Returns a random name that we can use to name a person in the world."

	^ NameList atRandom.! !

!RandomUtilities class methodsFor: 'as yet unclassified' stamp: 'VU 10/30/2004 16:08'!
worldExample

| puyanModel bookModel tileSet puyanSet bookSet puyanObject bookObject mapView layout anotherLayout map |

puyanModel := Person new.
puyanModel name: 'Puyan the Little Guy'.
puyanModel gender: #male.

bookModel := Item new.
bookModel name: 'Book'.

tileSet := FramesetManager instance loadFrameset: 'floor.gif'.
puyanSet := FramesetManager instance loadFrameset: 'puyan.gif'.
bookSet := FramesetManager instance loadFrameset: 'book.gif'.

puyanObject := AnimatedMapObject onFrameset: puyanSet.
puyanObject coordinates: (3@3).
puyanObject stepTime: 300.
puyanObject model: puyanModel.

bookObject := MapObject new.
bookObject image: (bookSet frame: 1).
bookObject coordinates: (1@1).
bookObject model: bookModel.

mapView := MapMorph new.

layout := DiamondLayout new.
layout tileSize: 48@23.

anotherLayout := StaggeredLayout new.
anotherLayout tileSize: 48@23.

map := #(
  1 1 1 1 2 1
  1 3 4 3 2 1
  1 3 6 3 2 1
  1 3 5 3 8 1
  2 2 2 8 8 1
  1 2 3 4 5 6
  ).

mapView locationGrid layoutPolicy: layout.
mapView locationGrid tileset: tileSet.
mapView locationGrid buildFromIntArray: map ofWidth: 6.
mapView locationGrid addMorphFront: puyanObject.
mapView locationGrid addMorphFront: bookObject.
mapView locationGrid position: (0@0 - (mapView scroller submorphBounds origin)).

mapView extent: (300@300).

"mapView fitContents."

mapView openInWorld.! !

!RandomUtilities class methodsFor: 'as yet unclassified' stamp: 'VU 12/1/2004 21:36'!
worldExample2
  "Here, we will create a couple rooms and a bunch of things to populate the world with."

  | puyanModel joseModel vladimirModel dungModel andrewModel bookModel roomCommons roomTALab keyModel portalCommonsToTA portalTAToCommons coffeeModel foodModel |

  "First, reset the world:"
  GameEngine delete.

  "Create some people:"
  puyanModel := Person new.
  puyanModel name: 'Puyan'.
  puyanModel gender: #male.
  puyanModel addEffect: SleepEffect new.

  joseModel := Person new.
  joseModel name: 'Jose'.
  joseModel gender: #male.

  vladimirModel := Person new.
  vladimirModel name: 'Vladimir'.
  vladimirModel gender: #male.

  dungModel := Person new.
  dungModel name: 'Dung'.
  dungModel gender: #male.

  andrewModel := Person new.
  andrewModel name: 'Andrew'.
  andrewModel gender: #male.

  "Create some items:"
  bookModel := Book new.
  keyModel := Key new.
  coffeeModel := Coffee new.
  foodModel := Food new.


  "Create a couple locations:"
  roomCommons := Location new.
  roomCommons name: 'Commons'.
  roomCommons width: 20 height: 8.
  roomCommons addWorldObject: puyanModel at: 16 at: 4.
  roomCommons addWorldObject: bookModel at: 10 at: 1.
  roomCommons addWorldObject: keyModel at: 14 at: 6.
  roomCommons addWorldObject: coffeeModel at: 2 at: 2.
  roomCommons addWorldObject: foodModel at: 15 at: 2.

  roomTALab := Location new.
  roomTALab name: 'TA Lab'.
  roomTALab width: 10 height: 10.
  roomTALab floorType: 3.
  roomTALab addWorldObject: joseModel at: 8 at: 1.

  "Create room connections:"
  portalCommonsToTA := Portal new.
  portalCommonsToTA location: roomTALab.
  portalCommonsToTA locked: true.
  portalCommonsToTA alignment: 4.
  roomCommons addWorldObject: portalCommonsToTA at: 12 at: 8.

  portalTAToCommons := Portal new.
  portalTAToCommons location: roomCommons.
  portalTAToCommons locked: false.
  portalTAToCommons alignment: 2.
  roomTALab addWorldObject: portalTAToCommons at: 2 at: 1.

  GameEngine instance changeLocation: roomCommons.! !


RandomUtilities initialize!
