Object subclass: #SimAction
	instanceVariableNames: 'effects '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Model'!
!SimAction commentStamp: 'ACK 11/5/2004 02:10' prior: 0!
This class of objects and either effect a persons factors, make them do an action(such as picking up something or talking), or can do both.

This class should be extended to make more specific SimActions. Do not instantiate.!


!SimAction methodsFor: 'modifiers' stamp: 'ACK 10/29/2004 22:50'!
addEffect: inEffect
	"adds the effect to the effect bag"

	effects add: inEffect.

! !

!SimAction methodsFor: 'modifiers' stamp: 'ACK 10/29/2004 22:49'!
effects: bag
	"sets all the effects for this action to the effects in the passed in bag"

	effects := bag.

! !


!SimAction methodsFor: 'accessors' stamp: 'ACK 10/29/2004 22:48'!
effects
	"returns the bag of effects for this action"

	^effects.
! !

!SimAction methodsFor: 'accessors' stamp: 'dqn 11/22/2004 18:30'!
object
	"will be overwritten by sub class"! !


!SimAction methodsFor: 'xml' stamp: 'ACK 10/29/2004 22:54'!
tagName
  ^ 'action'.! !

!SimAction methodsFor: 'xml' stamp: 'ACK 10/29/2004 23:13'!
writeXML: xmlWriter
	"This is not used in the current design...
	writes xml for an action"

	xmlWriter startTag: self tagName. "open tag action"

	"writing actions"
	xmlWriter startTag: 'factors'; endTag.
	WorldObject xmlizeBag: effects using: xmlWriter tagged: 'action'.
	xmlWriter endTag: 'factors'.

	xmlWriter endTag: self tagName.

	! !


!SimAction methodsFor: 'creation' stamp: 'ACK 10/29/2004 22:52'!
initialize
  	"Initializes the action."
	
 	effects := Bag new.! !


!SimAction methodsFor: 'actions' stamp: 'VU 10/30/2004 17:23'!
doAction: aWorldObject
	"applies the effects of the action to the persons factors"

     ^ self subclassResponsibility.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SimAction class
	instanceVariableNames: ''!

!SimAction class methodsFor: 'as yet unclassified' stamp: 'ACK 10/29/2004 22:47'!
new
	"create"

	^super new initialize.! !
