Object subclass: #SimWorld
	instanceVariableNames: 'locations '
	classVariableNames: 'Instance '
	poolDictionaries: ''
	category: 'SimTech-Model'!
!SimWorld commentStamp: 'JMC 10/22/2004 19:16' prior: 0!
The SimWorld class is a Singleton which handles the major functions of representing the World of SimTech.

It basically contains a list of Locations and functions to add and remove locations.

It also handles the job of exporting game state data.
!


!SimWorld methodsFor: 'location handling' stamp: 'JMC 10/22/2004 19:38'!
addLocation: location
	"Add the location to the locations in the World"

	! !

!SimWorld methodsFor: 'location handling' stamp: 'JMC 10/22/2004 19:41'!
removeLocation: location
	"Remove the location from the list of locations in the World"

	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SimWorld class
	instanceVariableNames: ''!

!SimWorld class methodsFor: 'data saving' stamp: 'JMC 10/22/2004 19:43'!
writeXML
	"Write the XML for the SimWorld data saving"

	! !


!SimWorld class methodsFor: 'Singletonness' stamp: 'JMC 10/29/2004 18:43'!
delete
	"This will delete the current instance of the Singleton, this is primarily for debugging"

	^(Instance := nil).

	! !

!SimWorld class methodsFor: 'Singletonness' stamp: 'JMC 10/29/2004 22:30'!
instance
	"Return the current instance of the Singleton"

	Instance isNil ifTrue: [ Instance := super new. ].

	^Instance.
! !

!SimWorld class methodsFor: 'Singletonness' stamp: 'JMC 10/29/2004 18:56'!
new
	"This should never be called due to the Singleton design pattern"

	^self error: 'SimWorld cannot be instantiated, use initialize instead'.
! !
