WorldObject subclass: #Thing
	instanceVariableNames: 'description '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-Model'!
!Thing commentStamp: 'ACK 10/29/2004 19:16' prior: 0!
The Thing class, as defined by the requirements, is simply a class of "things".

There is noting more to this, it is a straightforward class.  Really, it should act as an abstract class because the useable, useful objects reside as extensions of the Thing type: that is Items, Furniture, etc.!


!Thing methodsFor: 'modifiers' stamp: 'ACK 10/29/2004 19:18'!
description: newDescription
	"Set the description of the Thing"

	description := newDescription.! !


!Thing methodsFor: 'creation' stamp: 'ACK 10/29/2004 19:18'!
initialize
	"Initialize everything needed for a thing"

	super initialize.
	! !


!Thing methodsFor: 'accessors' stamp: 'ACK 10/29/2004 19:18'!
description
	"Return the description of the Thing"

	^description.! !


!Thing methodsFor: 'xml' stamp: 'ACK 10/29/2004 19:21'!
tagName
  ^ 'thing'.! !

!Thing methodsFor: 'xml' stamp: 'ACK 10/29/2004 19:20'!
writeXML: xmlWriter
	"Write the necessary XML.  The actual process of writing the XML is 
	 straightforward.  Please see the comments in the code for specifics."

	xmlWriter startTag: self tagName. "Open our tag"
	xmlWriter attribute: 'description' value: (self description asString).
	xmlWriter endTag. "Close the tag with a >"
	
	"Write Attributes"
     xmlWriter startTag: 'attributes'; endTag.
     WorldObject xmlizeDictionary: attributes using: xmlWriter tagged: 'attribute'.
     xmlWriter endTag: 'attributes'.

	"Write effects"
	xmlWriter startTag: 'effectBag'; endTag.
	WorldObject xmlizeBag: effectBag using: xmlWriter tagged: 'effectBag'.
	xmlWriter endTag: 'effectBag'.

	xmlWriter endTag: self tagName. "Close tag with </Thing>"! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Thing class
	instanceVariableNames: ''!

!Thing class methodsFor: 'as yet unclassified' stamp: 'ACK 10/29/2004 19:27'!
new
	"calls instance initialize"

	^ super new initialize.
	! !
