Object subclass: #PathManager
	instanceVariableNames: ''
	classVariableNames: 'Instance '
	poolDictionaries: ''
	category: 'SimTech-ResourceManagement'!

!PathManager methodsFor: 'paths' stamp: 'VU 11/27/2004 13:11'!
basePath
  "This function returns the file directory that represents the base path of the project. Basically, this will return the root directory of the game from which we can then reference other directories, like saves, images, etc."

  ^ (FileDirectory on: Smalltalk imagePath) directoryNamed: '..\Milestones\M6\'.! !

!PathManager methodsFor: 'paths' stamp: 'VU 11/1/2004 12:48'!
imagePath
  "This function returns the file directory representing the fully qualified path for the directory that contains all the artwork for the game."

  ^ self basePath directoryNamed: 'images'.! !

!PathManager methodsFor: 'paths' stamp: 'VU 11/1/2004 12:49'!
savePath
  "Returns the path to the directory that contains the saved games."

  ^ self basePath directoryNamed: 'saves'.! !

!PathManager methodsFor: 'paths' stamp: 'VU 11/7/2004 13:03'!
sourcePath
  "Returns the path for the source directory."

  ^ self basePath directoryNamed: 'src'.! !

!PathManager methodsFor: 'paths' stamp: 'VU 11/1/2004 12:49'!
worldPath
  "Returns the directory that contains the pre-defined worlds that the player can play in."

  ^ self basePath directoryNamed: 'worlds'.

  ! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PathManager class
	instanceVariableNames: ''!

!PathManager class methodsFor: 'singleton' stamp: 'VU 11/1/2004 12:38'!
instance
  "Returns the one and only instance of this path manager class."

  Instance isNil ifTrue: [ Instance := PathManager new. ].

  ^ Instance.! !
