'From Squeak3.6 of ''6 October 2003'' [latest update: #5429] on 2 December 2004 at 4:47:06 am'!
Object subclass: #Saver
	instanceVariableNames: 'fileName '
	classVariableNames: 'Instance '
	poolDictionaries: ''
	category: 'SimTech-Utilities'!
!Saver commentStamp: 'dqn 11/7/2004 00:39' prior: 0!
Ask user a file name to save the current game.
To use:
The feature is already included in the game. To use it seperately: Saver instance open.!


!Saver methodsFor: 'as yet unclassified' stamp: 'dqn 11/7/2004 02:54'!
open
	"open Saver, ask for file name to save and call save"
	fileName _ FillInTheBlankMorph request: 'Type file name to save to'.
	(fileName isNil or: [fileName = '']) ifTrue:
	[^ self].
	self save! !

!Saver methodsFor: 'as yet unclassified' stamp: 'dqn 12/1/2004 04:09'!
openSaveWorld
	"open Saver, ask for file name to save and call save"
	fileName _ FillInTheBlankMorph request: 'Type file name to save to'.
	(fileName isNil or: [fileName = '']) ifTrue:
	[^ self].
	self saveWorld! !

!Saver methodsFor: 'as yet unclassified' stamp: 'JMC 11/18/2004 19:54'!
save
	"open a stream and save the whole damm thing"
	|stream|
	
	(fileName endsWith: '.sav') ifFalse:
	[
		fileName _ fileName, '.sav'.
	].

	stream _ ReferenceStream on:
		(PathManager instance savePath forceNewFileNamed: fileName).

	GameEngine stop.

	GameEngine instance deinit.

	stream nextPut: GameEngine instance.

	GameEngine instance reinit.

	stream close.
! !

!Saver methodsFor: 'as yet unclassified' stamp: 'dqn 12/1/2004 04:11'!
saveWorld
	"open a stream and save the whole damm thing"
	|stream gameEngineCopy locationList mapObjectBag|
	
	(fileName endsWith: '.sav') ifFalse:
	[
		fileName _ fileName, '.sav'.
	].

	stream _ ReferenceStream on:
		(PathManager instance savePath forceNewFileNamed: fileName).

	GameEngine stop.

	GameEngine instance deinit.

	gameEngineCopy _ GameEngine instance veryDeepCopy. 

	locationList _ gameEngineCopy locationList.
	
	(locationList) do: 
	[
		: location |
		mapObjectBag _ location worldObjectBag.
		(mapObjectBag) do:
		[
			: mapObject|
			(mapObject model isKindOf: Person) ifTrue:
			[
				location removeWorldObject: mapObject model.
			].
		].
	].

	stream nextPut: gameEngineCopy.

	GameEngine instance reinit.

	stream close.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Saver class
	instanceVariableNames: ''!

!Saver class methodsFor: 'as yet unclassified' stamp: 'dqn 11/7/2004 03:06'!
instance
	"create or return the single instance of the Saver"
	(Instance isNil) ifTrue:
	[ Instance _ super new].
	^ Instance.! !

!Saver class methodsFor: 'as yet unclassified' stamp: 'dqn 11/7/2004 03:07'!
new
	"stop creating Saver outside"
	^ nil.! !
