Object subclass: #StringTokenizer
	instanceVariableNames: 'delimiter stream portalBag '
	classVariableNames: 'Instance '
	poolDictionaries: ''
	category: 'SimTech-Utilities'!
!StringTokenizer commentStamp: 'dqn 11/7/2004 00:39' prior: 0!
Will not be used.!


!StringTokenizer methodsFor: 'initialize' stamp: 'dqn 10/30/2004 13:54'!
delimiter
	^ delimiter.! !

!StringTokenizer methodsFor: 'initialize' stamp: 'dqn 10/30/2004 13:54'!
delimiter: aDelimiter
	delimiter _ aDelimiter.! !

!StringTokenizer methodsFor: 'initialize' stamp: 'dqn 11/1/2004 16:22'!
initialize
	delimiter _ '[]!!<>=$ ' asString.
	portalBag _ Bag new.! !

!StringTokenizer methodsFor: 'initialize' stamp: 'dqn 10/30/2004 13:48'!
stream
	^ stream! !

!StringTokenizer methodsFor: 'initialize' stamp: 'dqn 10/30/2004 13:48'!
stream: aStream
	stream _ aStream.! !


!StringTokenizer methodsFor: 'token' stamp: 'dqn 11/1/2004 16:38'!
nextToken
	| c retVal|
	(stream atEnd) ifTrue:
	[
		^ nil.
	].
	[(self isDelimiter: (c _ stream next)) and: [(c = $") ifTrue: [false] ifFalse: [true]]] whileTrue:[].
	retVal _ String new.
	(c = $") ifFalse:
	[
		retVal _ retVal, c asString.
		[(self isDelimiter: (c _ stream next))] whileFalse:
		[
			retVal _ retVal, c asString.
		].
	]
	ifTrue:
	[
		[(c _ stream next) = $"] whileFalse:
		[
			retVal _ retVal, c asString.
		].
	].
	^retVal.
	! !

!StringTokenizer methodsFor: 'token' stamp: 'dqn 10/30/2004 17:20'!
skipToken
	self nextToken.
	^ (self nextToken).! !


!StringTokenizer methodsFor: 'delimiter' stamp: 'dqn 10/30/2004 14:02'!
isDelimiter: c
	^ (delimiter includes: c ).! !


!StringTokenizer methodsFor: 'build' stamp: 'dqn 11/1/2004 02:40'!
buildGameEngine
	| token location currentLocationID |
	GameEngine delete.
	token _ self nextToken. "GameEngine"
	token _ self skipToken. "currentLocationID value"
	currentLocationID _ token asNumber.
	[token = '/GameEngine'] whileFalse:
	[
		token _ self nextToken. "locations"
		(token = 'locations') ifTrue:
		[
			[token = '/locations'] whileFalse:
			[
				token _ self nextToken.			
				(token = 'location') ifTrue:
				[	
					location _ self buildLocation.
					(location locationID = currentLocationID) ifTrue:
					[
						GameEngine instance changeLocation: location.
					].
				].
			].
		].
	].

	self finishPortal.! !

!StringTokenizer methodsFor: 'build' stamp: 'dqn 11/1/2004 17:13'!
buildLocation
	| location person portal item token worldObject furniture|
	location _ Location new.
	token _ self nextToken. "id="
	token _ self nextToken. "id value"
	location locationID: token asNumber.
	
	location name: self skipToken. "name"

	token _ self nextToken. "locationArray"
	location width: self skipToken asNumber height: self skipToken asNumber.
	token _ self nextToken. "/locationArray"

	token _ self nextToken. "worldObjectBag"
	[token = '/worldObjectBag'] whileFalse:
	[
		token _ self nextToken. 
		(token = 'person') ifTrue:
		[
			person _ self buildPerson.
			worldObject _ person.
			location addWorldObject: worldObject at: worldObject coordinates x at: worldObject coordinates y. 
		].

		(token = 'portal') ifTrue:
		[
			portal _ self buildPortal.
			worldObject _ portal.
			location addWorldObject: worldObject at: worldObject coordinates x at: worldObject coordinates y. 
		].

		(token = 'item') ifTrue:
		[
			item _ self getItem.
			worldObject _ item.
			location addWorldObject: worldObject at: worldObject coordinates x at: worldObject coordinates y. 
		].

		(token = 'furniture') ifTrue:
		[
			furniture _ self getFurniture.
			worldObject _ furniture.
			location addWorldObject: worldObject at: worldObject coordinates x at: worldObject coordinates y. 
		].
	].
	self nextToken.
	^location.! !

!StringTokenizer methodsFor: 'build' stamp: 'dqn 11/1/2004 01:47'!
buildPerson
	| person token oldCoordinates coordinates|
	person _ Person new initialize.
	token _ self nextToken. "name="
	token _ self nextToken. "name value"
	person name: token.

	token _ self nextToken. "gender="
	token _ self nextToken. "gender value"
	person gender: token.
	
	oldCoordinates _ self getCoordinates.
	person coordinates: oldCoordinates.
		
	coordinates _ self getCoordinates.
	person coordinates: coordinates.

	token _ self nextToken. "attributes"
	[token = '/attributes'] whileFalse:
	[
		token _ self nextToken. "/attributes"
		(token = 'attribute') ifTrue:
		[
			person attribute: (self skipToken) is: (self skipToken).
		].		
	].

	token _ self nextToken. "factors"
	[token = '/factors'] whileFalse:
	[
		token _ self nextToken. "/factors"
		(token = 'factor') ifTrue:
		[
			person factor: (self skipToken) is: (self skipToken asNumber).
		].		
	].

	token _ self nextToken. "itemBag"	
	token _ self nextToken. "items"
	[token = '/itemBag'] whileFalse:
	[
		token _ self nextToken.
		(token = 'item') ifTrue:
		[
			person addItem: (self getItem).
		].
	].
	"personalEffects - not necessary"	
"	token _ self nextToken. 
	[token = '/personalEffects'] whileFalse:
	[
		token _ self nextToken.
		(token = 'personalEffect') ifTrue:
		[
			person addPersonalEffect: self getEffect.
		].
	].
"
	token _ self nextToken. "effectBag"
	[token = '/effectBag'] whileFalse:
	[
		token _ self nextToken.
		(token = 'effect') ifTrue:
		[
			person addEffect: self getEffect.
		].
	].
	self nextToken.
	^person.! !

!StringTokenizer methodsFor: 'build' stamp: 'dqn 11/1/2004 00:23'!
buildPortal
	|portal oldCoordinates coordinates|
	portal _ Portal new initialize.
	portal alignment: self skipToken asNumber.
	portal locked: (self skipToken = 'true').
	portal locationID: (self skipToken asNumber).

	oldCoordinates _ self getCoordinates.
	portal coordinates: oldCoordinates.
		
	coordinates _ self getCoordinates.
	portal coordinates: coordinates.

	self nextToken.
	
	portalBag add: portal.
	^portal.! !

!StringTokenizer methodsFor: 'build' stamp: 'dqn 11/1/2004 00:22'!
finishPortal
	|locationList |
	locationList _ GameEngine instance locationList.
	portalBag do:
	[
		: aPortal|
		locationList do:
		[
			: aLocation |
			((aLocation locationID) = (aPortal locationID)) ifTrue:
			[
				aPortal location: aLocation.
			]. 
		].
	].! !

!StringTokenizer methodsFor: 'build' stamp: 'dqn 11/1/2004 00:46'!
getCoordinates
	|coordinates x y token|
	self nextToken.
	token _ self skipToken.
	x _ token asNumber.
	token _ self skipToken.
	y _ token asNumber.
	coordinates _ (x @ y).
	self nextToken.
	^ coordinates.! !

!StringTokenizer methodsFor: 'build' stamp: 'dqn 10/30/2004 19:52'!
getEffect
	|token effect|
	effect _ nil.
	self nextToken; nextToken.
	token _ self nextToken.
	(token = 'SleepEffect') ifTrue:
	[
		effect _ SleepEffect new initialize.
	].
	(token = 'HappyEffect') ifTrue:
	[
		effect _ HappyEffect new initialize.
	].
	(token = 'AngryEffect') ifTrue:
	[
		effect _ AngryEffect new initialize.
	].
	(token = 'HungryEffect') ifTrue:
	[
		effect _ HungryEffect new initialize.
	].
	^effect.
! !

!StringTokenizer methodsFor: 'build' stamp: 'dqn 11/1/2004 17:04'!
getFurniture
	"read an funiture from stream"
	| aFurniture token oldCoordinates coordinates|
	aFurniture _ Furniture new initialize.
	aFurniture name: self skipToken. "furniture's name"
	aFurniture description: self skipToken. "furniture's description"
	
	token _ self nextToken. "attributes"
	[token = '/attributes'] whileFalse:
	[
		token _ self nextToken.
		(token = 'attribute') ifTrue:
		[
			aFurniture attribute: self skipToken is: self skipToken.
		]
	].

	oldCoordinates _ self getCoordinates.
	aFurniture coordinates: oldCoordinates.
		
	coordinates _ self getCoordinates.
	aFurniture coordinates: coordinates.


	token _ self nextToken. "effects"
	[token = '/effects'] whileFalse:
	[
		token _ self nextToken.
		(token = 'effect') ifTrue:
		[
			aFurniture addEffect: self getEffect.
		].
	].
	
	^aFurniture.
! !

!StringTokenizer methodsFor: 'build' stamp: 'dqn 11/1/2004 00:09'!
getItem
	"read an item from stream"
	| anItem token oldCoordinates coordinates|
	anItem _ Item new.
	anItem name: self skipToken. "item's name"
	anItem description: self skipToken. "item's description"
	
	token _ self nextToken. "attributes"
	[token = '/attributes'] whileFalse:
	[
		token _ self nextToken.
		(token = 'attribute') ifTrue:
		[
			anItem attribute: self skipToken is: self skipToken.
		]
	].

	oldCoordinates _ self getCoordinates.
	anItem coordinates: oldCoordinates.
		
	coordinates _ self getCoordinates.
	anItem coordinates: coordinates.


	token _ self nextToken. "effects"
	[token = '/effects'] whileFalse:
	[
		token _ self nextToken.
		(token = 'effect') ifTrue:
		[
			anItem addEffect: self getEffect.
		].
	].
	
	^anItem.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

StringTokenizer class
	instanceVariableNames: ''!

!StringTokenizer class methodsFor: 'singleTon' stamp: 'dqn 11/1/2004 00:27'!
instance
	(Instance isNil) ifTrue:
	[
		Instance _ super new initialize.
	].
	^ Instance.! !
