MapObject subclass: #AnimatedMapObject
	instanceVariableNames: 'frameset currentFrame currentFrameNumber stepTime animationMode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-View'!

!AnimatedMapObject methodsFor: 'accessing' stamp: 'VU 10/18/2004 17:51'!
stepTime
  "Returns the amount of time that we want to spend between frames of animation."
  ^ stepTime.! !


!AnimatedMapObject methodsFor: 'animation' stamp: 'VU 10/18/2004 18:33'!
step
  "Performs one step of the animation. Basically, here just uses the next frame of the animation."

  currentFrameNumber := currentFrameNumber + 1.

  (currentFrameNumber > frameset frameCount) ifTrue: [
    (animationMode = #loop) ifTrue: [ currentFrameNumber := 1. ] ifFalse: [
    (animationMode = #once) ifTrue: [ currentFrameNumber := frameset frameCount. ]. ].
  ].

  self frame: (frameset frame: currentFrameNumber).
  ! !


!AnimatedMapObject methodsFor: 'initialization' stamp: 'VU 10/30/2004 19:46'!
initializeTo: frames
  "Initializes the image morph."
  frameset := frames.
  currentFrameNumber := 1.
  animationMode := #loop.
  stepTime := 1000.
  self specialInitialize.! !

!AnimatedMapObject methodsFor: 'initialization' stamp: 'VU 10/30/2004 19:43'!
specialInitialize
  "This function will be overridden by subclasses for their special initialization needs."
  self frame: (frameset frame: 1).! !


!AnimatedMapObject methodsFor: 'modifying' stamp: 'VU 10/18/2004 17:52'!
stepTime: newTime
  "Sets the new step time for the animated morph."
   stepTime := newTime.! !


!AnimatedMapObject methodsFor: 'private' stamp: 'VU 10/18/2004 17:58'!
frame: aFrame

  (currentFrame isNil) ifFalse: [self position: ((self position) + (currentFrame anchor)). ].
  self position: ((self position) - (aFrame anchor)).

  currentFrame := aFrame.

  self image: currentFrame.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

AnimatedMapObject class
	instanceVariableNames: ''!

!AnimatedMapObject class methodsFor: 'instance creation' stamp: 'VU 10/25/2004 23:30'!
onFrameset: set
  "Creates a new animated image morph on the frameset passed in."
  ^ self new initialize initializeTo: set.! !
