IsometricLayout subclass: #DiamondLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-View'!
!DiamondLayout commentStamp: 'VU 10/25/2004 21:14' prior: 0!
The diamond layout implements a type of isometric layout which allows us to lay out the map the same way as it is done in the Sims. Using this layout, the map will look something like this:

   /\
  /\/\
 /\/\/\
/\/\/\/\
\/\/\/\/
 \/\/\/
  \/\/
   \/

Hence the name: diamond map.
!


!DiamondLayout methodsFor: 'layout' stamp: 'VU 10/28/2004 19:47'!
morphCoordinatesFor: aPoint withTileDimensions: aDimension
  "Given the desired map coordinates of the morph, and the width of the tile, "
  "this will return the real coordinates where the tile should be put assuming"
  "that the map starts at coordinates (0@0) in the top-left corner."

  | x y |

  x := ((aPoint x) - (aPoint y)) * (aDimension x // 2).
  y := ((aPoint x) + (aPoint y)) * (aDimension y // 2).

  ^ x@y.! !
