Morph subclass: #LocationGrid
	instanceVariableNames: 'tileset '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimTech-View'!

!LocationGrid methodsFor: 'accessing' stamp: 'VU 10/25/2004 23:20'!
tileImage: index
  "Returns the frame for the tile using the index into the tileset."
   ^ tileset frame: index.! !

!LocationGrid methodsFor: 'accessing' stamp: 'VU 10/25/2004 23:19'!
tileset
  "Returns the tileset used for this location."

  ^ tileset.! !


!LocationGrid methodsFor: 'modifying' stamp: 'VU 10/25/2004 23:22'!
tileset: aFrameset
  "Sets the tileset to the frameset passed in."
  tileset := aFrameset.! !


!LocationGrid methodsFor: 'grid initialization' stamp: 'VU 10/30/2004 20:14'!
buildFromIntArray: anArray ofWidth: width
  "Given an array of integers, simply builds the map of the dimensions passed in."

  | obj x y |

"  self initialize."

  anArray withIndexDo: [:value :index |
    x := ((index-1) \\ width).
    y := ((index-1) // width).

    obj := MapObject new.
    obj coordinates: (x@y).
    obj image: (self tileImage: value).
    self addMorphFront: obj.
  ].

  self layoutChanged.! !

!LocationGrid methodsFor: 'grid initialization' stamp: 'VU 12/1/2004 20:45'!
buildFromLocation: aLocation
  "Initializes the location grid from the location."

  | obj objects |

"  self initialize."

  (1 to: aLocation height) do: [ :y |
    (1 to: aLocation width) do: [ :x |
      obj := MapObject new.
      obj coordinates: (x@y).
      obj image: (self tileImage: aLocation floorType).
      self addMorphFront: obj.
    ].
  ].

  objects := aLocation locationObjects.
  objects do: [ :wo |
    self addMorphFront: wo.
  ].

  self layoutChanged.! !

!LocationGrid methodsFor: 'grid initialization' stamp: 'VU 11/6/2004 15:43'!
initialize
	"Resets the location grid."
	super initialize.

	self submorphs do: [ :sm |
		(sm isKindOf: MapObject) ifTrue: [
			sm delete.
		].
	].! !
