AbstractDialog subclass: #RadioButtonDialog
	instanceVariableNames: 'valueArray '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Vladimir-Utilities'!

!RadioButtonDialog methodsFor: 'private' stamp: 'VU 11/7/2004 15:28'!
privateGetContent
	"This function will return the morph that will provide the content for the user to type stuff in."

	| assoc box |

	assoc _ 'key' -> (valueArray at: 1).

	box _ RadioButtonGroupMorph new initializeWithValues: valueArray.
	box target: assoc;
		getSelector: #value;
		setSelector: #value:;
		acceptTarget: self;
		acceptSelector: #response:.

	^ box.! !

!RadioButtonDialog methodsFor: 'private' stamp: 'VU 11/7/2004 14:57'!
privateGetContentSelector
	"Will respond with the selector that needs to be called on the content morph to get the user slection from it."

	^ #accept.! !

!RadioButtonDialog methodsFor: 'private' stamp: 'VU 11/7/2004 15:04'!
privateSetArray: anArray
	valueArray := anArray.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RadioButtonDialog class
	instanceVariableNames: ''!

!RadioButtonDialog class methodsFor: 'instance creation' stamp: 'VU 11/7/2004 15:05'!
request: queryString withValues: array

	"Creates an instance of the dialog in the world with the specified title, at the specified point"

	^ self
		request: queryString
		withValues: array
		centerAt: (ActiveHand ifNil:[Sensor]) cursorPoint
		inWorld: ActiveWorld! !

!RadioButtonDialog class methodsFor: 'instance creation' stamp: 'VU 11/7/2004 15:04'!
request: queryString withValues: array centerAt: aPoint inWorld: aWorld

	"Creates an instance of the dialog in the world with the specified title, at the specified point"

	| aDialog |

	aDialog := self new.
	aDialog privateSetArray: array.
	aDialog setQuery: queryString.
	aWorld addMorph: aDialog centeredNear: aPoint.

	^ aDialog getUserResponse.! !
